## performous 0.5.1

=== CMakeLists.txt ===
project(Performous CXX)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)
set(PROJECT_VERSION "0.5.1")

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

include(cmake/performous-packaging.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=RelWithDebInfo. Use ccmake to set a proper value.")
	SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(WIN32)
	set(SHARE_INSTALL "." CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
else(WIN32)
	if(NOT SHARE_INSTALL)
		set(SHARE_INSTALL "share/games/performous" CACHE STRING "Data file install path. Must be a relative path (from CMAKE_INSTALL_PREFIX), with no trailing slash.")
	endif(NOT SHARE_INSTALL)
endif(WIN32)

mark_as_advanced(SHARE_INSTALL)

# Need to find the headers even if they haven't been installed yet:
include_directories(libs/plugin++/include)
include_directories(libs/libda/include)

#need to put here do setting LOCALE_DIR variable
find_package(Gettext)
if(Gettext_FOUND)
	if(NOT LOCALE_DIR)
		if(WIN32)
			SET(LOCALE_DIR "locale")
			SET(LOCALE_DIR_WIN32_PREFIX "bin/")
		elseif(APPLE)
			SET(LOCALE_DIR "share/locale")
		else()#other os
			SET(LOCALE_DIR "/usr/share/locale")
		endif(WIN32)
	endif(NOT LOCALE_DIR)
	
	if(NOT LOCALE_DIR)
		message(QUIET "Set LOCALE_DIR to path to get Gettext working")
	else()
		find_package(Msgfmt)
		if(Msgfmt_FOUND)
			message(STATUS "Found msgfmt to convert language file. Translation enabled")
			add_subdirectory(lang)
		else()
			message(STATUS "Cannot find msgfmt to convert language file. Translation won't be enabled")
		endif()
	endif(NOT LOCALE_DIR)
endif(Gettext_FOUND)
add_subdirectory(libs)
add_subdirectory(themes)
add_subdirectory(data)
add_subdirectory(game)
add_subdirectory(docs)

set(LIB_SUFFIX "" CACHE STRING "Optional suffix to use on lib folders (e.g. 64 for lib64)")

option(ENABLE_EDITOR "Enable experimental song editor (doesn't work)" OFF)

if (ENABLE_EDITOR)
  add_subdirectory(editor)
endif (ENABLE_EDITOR)

option(ENABLE_TOOLS "Enable extra tools (e.g. Singstar ripper)" ON)

if (ENABLE_TOOLS)
  add_subdirectory(tools)
endif (ENABLE_TOOLS)

if(WIN32)
	option(ENABLE_VERSIONING "Add number version information. This allows to add version information to exe. Be carefull, in beta (and a lot useless)" OFF)
endif(WIN32)

=== data/CMakeLists.txt ===
set(APPLICATION_FILE "performous.desktop")
set(PIXMAP_FILE      "performous.xpm")
set(CONFIG_FILE      "schema.xml")

if(UNIX)
	install(FILES ${APPLICATION_FILE} DESTINATION "share/applications/")
	install(FILES ${PIXMAP_FILE} DESTINATION "share/pixmaps")
endif(UNIX)

install(FILES ${CONFIG_FILE} DESTINATION "${SHARE_INSTALL}/config/")

file(GLOB XSL_FILES "*.xsl")
install(FILES ${XSL_FILES} DESTINATION "${SHARE_INSTALL}/xsl/")

file(GLOB SOUND_FILES "sounds/*.ogg")
install(FILES ${SOUND_FILES} DESTINATION "${SHARE_INSTALL}/sounds/")

file(GLOB BG_FILES "backgrounds/*.svg")
install(FILES ${BG_FILES} DESTINATION "${SHARE_INSTALL}/backgrounds/")

=== docs/CMakeLists.txt ===

if(UNIX)
	find_program(HELP2MAN help2man DOC "Location of the help2man program")
	find_program(GZIP gzip DOC "Location of the gzip program")
	mark_as_advanced(HELP2MAN)
	mark_as_advanced(GZIP)
	if(HELP2MAN AND GZIP)
		set(MANFILE ${CMAKE_CURRENT_BINARY_DIR}/performous.6.gz)
		set(H2MFILE ${CMAKE_CURRENT_SOURCE_DIR}/performous.h2m)
		set(PERFORMOUS_EXEC ${CMAKE_BINARY_DIR}/game/performous)
		add_custom_command(
			OUTPUT ${MANFILE}
			COMMAND ${HELP2MAN} ${PERFORMOUS_EXEC} -s 6 -i ${H2MFILE} -N | ${GZIP} > ${MANFILE}
			MAIN_DEPENDENCY ${H2MFILE}
			DEPENDS ${PERFORMOUS_EXEC}
			COMMENT "Building Performous man page"
			VERBATIM
		)
		add_custom_target(manpage ALL DEPENDS ${MANFILE})
		install(FILES ${MANFILE} DESTINATION share/man/man6)
	else(HELP2MAN AND GZIP)
		message("WARNING: One of the following is missing: help2man, gzip; performous man page will not be generated")
	endif(HELP2MAN AND GZIP)
	if(ENABLE_TOOLS AND GZIP)
		set(TOOLS "ss_pak_extract" "ss_extract" "ss_cover_conv" "ss_adpcm_decode" "ss_ipu_decode" "ss_ipu_conv")
		set(MAN_SECTION "1")
		foreach(TOOL ${TOOLS})
			set(TOOL_MANFILE ${CMAKE_CURRENT_SOURCE_DIR}/${TOOL}.${MAN_SECTION})
			set(TOOL_MANFILE_GZ ${CMAKE_CURRENT_BINARY_DIR}/${TOOL}.${MAN_SECTION}.gz)
			add_custom_command(
				OUTPUT ${TOOL_MANFILE_GZ}
				COMMAND ${GZIP} -c ${TOOL_MANFILE} > ${TOOL_MANFILE_GZ}
				MAIN_DEPENDENCY ${TOOL_MANFILE}
				COMMENT "Building ${TOOL} man page"
				VERBATIM
			)
			add_custom_target(${TOOL}.${MAN_SECTION} ALL DEPENDS ${TOOL_MANFILE_GZ})
			install(FILES ${TOOL_MANFILE_GZ} DESTINATION share/man/man${MAN_SECTION})
		endforeach(TOOL)
	endif(ENABLE_TOOLS AND GZIP)
endif(UNIX)

=== editor/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

FILE(GLOB SOURCE_FILES "*.cc")
FILE(GLOB HEADER_FILES "*.hh")

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES})

# Libraries

find_package(Boost 1.34 REQUIRED COMPONENTS thread)
include_directories(${Boost_INCLUDE_DIRS})
set(LIBS ${LIBS} ${Boost_LIBRARIES})

# Find all the libs that don't require extra parameters
foreach(lib Magick++ AVFormat SWScale)
	find_package(${lib} REQUIRED)
	include_directories(${${lib}_INCLUDE_DIRS})
	set(LIBS ${LIBS} ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

# Set default compile flags for GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, enabling warnings")
	# -pedantic cannot be used because ffmpeg headers are b0rked
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++98 -Wall -Wextra")
	# Needed for ffmpeg.cc to compile cleanly on OSX (it's a (unsigned long) long story)
	add_definitions("-D__STDC_CONSTANT_MACROS")
endif(CMAKE_COMPILER_IS_GNUCXX)

add_executable(performous-editor ${SOURCES} ${SDL_SOURCES})
target_link_libraries(performous-editor da ${LIBS})

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.hh" "${CMAKE_CURRENT_BINARY_DIR}/config.hh" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

install(TARGETS performous-editor DESTINATION bin)

=== game/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

FILE(GLOB SOURCE_FILES "*.cc")
FILE(GLOB HEADER_FILES "*.hh")

if(WIN32)
  if(ENABLE_VERSIONING)
    set(COMMENTS)
	string(REGEX MATCHALL "([^\\.,^$]+)(\\.|,|$)"  VERSIONING ${PROJECT_VERSION})
	set(VERSIONS "MAJOR" "MINOR" "PATCH" "TWEAK")
	foreach(s ${VERSIONING})
		#we get the most-right number
		string(REGEX REPLACE "[^0-9]+$" "" s ${s})#removes most right part non-numeric (like .)
		#now we have a string in format <numbers-letters..........numbers>
		#take last numbers (if there are)
		#if string not empty, there are some numbers in right of string
		#otherwise, set a 0, to be sure that there's a number
		if(s STREQUAL "")
			set(s "0")
		endif()
		string(REGEX MATCH "[0-9]*$" s ${s})
		
		foreach(v ${VERSIONS})
			if(NOT VERSION_${v}_DONE)
				set(VERSION_${v}_DONE 1)
				set(VERSION_${v} "${s}")
				break()
			endif()
		endforeach()
	endforeach()

	foreach(v ${VERSIONS})
		if(NOT VERSION_${v}_DONE OR VERSION_${v} STREQUAL "") #For the substitution did before, in VERSION_${v} we have or a empty string (if all letters) or a number
			set(VERSION_${v} "0")
		endif()
	endforeach()
	message(STATUS "Setting .exe version: ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_TWEAK}")
  else(ENABLE_VERSIONING)
    set(COMMENTS "//")
  endif(ENABLE_VERSIONING)
  
  set(RESOURCE_FILES "${CMAKE_BINARY_DIR}/performous.rc")
  set(RESOURCE_OBJECT)#nothing
  
  configure_file("../win32/performous.cmake.rc" "${RESOURCE_FILES}")
  if(NOT MSVC)
    #in according to MinGW tools, we need to compile the rc file, and then link it into projects:
	#windres foo.rc foores.o
    #gcc -o foo.exe foo.o foores.o
	find_program(WINDRES windres)
	if(NOT WINDRES)
		message(STATUS "Cannot find windres. Will not create a versioned exe")
		set(RESOURCE_FILES)
		set(RESOURCE_OBJECT)
	else()
		set(RESOURCE_OBJECT "${CMAKE_BINARY_DIR}/performous.rc.o")
		execute_process(COMMAND "${WINDRES}" "${RESOURCE_FILES}" "${RESOURCE_OBJECT}")
	endif(NOT WINDRES)
  endif()
else()
  set(RESOURCE_FILES) #nothing
  set(RESOURCE_OBJECT)#nothing
endif()

set(SOURCES ${SOURCE_FILES} ${HEADER_FILES} ${RESOURCE_FILES})

# Libraries

find_package(Boost 1.36 REQUIRED COMPONENTS thread date_time program_options regex filesystem)
include_directories(${Boost_INCLUDE_DIRS})
list(APPEND LIBS ${Boost_LIBRARIES})

# Libraries are part of Performous build process (for now)
set(SLAVE_LIBS TRUE)
if(SLAVE_LIBS)
	list(APPEND LIBS da plugin++)
else()
	set(OUR_LIBS Plugin++ LibDA)
endif()

# Find all the libs that don't require extra parameters
foreach(lib ${OUR_LIBS} SDL PangoCairo LibRSVG LibXML++ GLEW AVFormat SWScale OpenGL Z Jpeg Png)
	find_package(${lib} REQUIRED)
	include_directories(${${lib}_INCLUDE_DIRS})
	list(APPEND LIBS ${${lib}_LIBRARIES})
	add_definitions(${${lib}_DEFINITIONS})
endforeach(lib)

find_package(Gettext)
if(Gettext_FOUND)
	include_directories(${Gettext_INCLUDE_DIRS})
	list(APPEND LIBS ${Gettext_LIBRARIES})
	add_definitions("-DUSE_GETTEXT")
	message(STATUS "Internationalization: Enabled")
else()
	message(STATUS "Internationalization: Disabled (libintl not found)")
endif()

find_package(PortMidi)
if(PortMidi_FOUND)
	include_directories(${PortMidi_INCLUDE_DIRS})
	list(APPEND LIBS ${PortMidi_LIBRARIES})
	add_definitions("-DUSE_PORTMIDI")
	message(STATUS "MIDI I/O: Enabled")
else()
	message(STATUS "MIDI I/O: Disabled (libportmidi not found)")
endif()

# Set default compile flags for GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, adding compile flags")
	# -pedantic cannot be used because ffmpeg headers are b0rked
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++98 -Wall -Wextra -Wno-missing-field-initializers")
	# Needed for ffmpeg.cc to compile cleanly on OSX (it's a (unsigned long) long story)
	add_definitions("-D__STDC_CONSTANT_MACROS")
endif(CMAKE_COMPILER_IS_GNUCXX)

add_executable(performous ${SOURCES} ${SDL_SOURCES} ${RESOURCE_OBJECT})
target_link_libraries(performous ${LIBS})

# Store library paths in executable
if(APPLE)
	set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
else()
	set_target_properties(performous PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

# Generate config.hh
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.hh" "${CMAKE_CURRENT_BINARY_DIR}/config.hh" @ONLY)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")

install(TARGETS performous DESTINATION bin)

=== lang/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
file(GLOB LANGUAGES *.po)
foreach(language ${LANGUAGES})
	string(REGEX REPLACE "(.+(\\\\|/))+" "" language ${language})
	string(REGEX REPLACE "\\.po$" "" language ${language})
	execute_process(COMMAND ${Msgfmt_BIN} -v ${CMAKE_CURRENT_SOURCE_DIR}/${language}.po -o ${CMAKE_CURRENT_BINARY_DIR}/${language}.mo)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${language}.mo DESTINATION ${LOCALE_DIR_WIN32_PREFIX}${LOCALE_DIR}/${language}/LC_MESSAGES RENAME ${CMAKE_PROJECT_NAME}.mo)
endforeach(language)

=== libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# Make plugin++ and libda not install themselves on the system
set(SLAVE_LIB TRUE)

add_subdirectory(plugin++)
add_subdirectory(libda)

=== tools/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

# Libraries

find_package(Boost 1.34 REQUIRED COMPONENTS filesystem program_options)
include_directories(${Boost_INCLUDE_DIRS})

# Find all the libs that don't require extra parameters
foreach(lib LibXML++ Magick++ Z Jpeg Tiff Png Freetype Z)
	find_package(${lib})
	if (${lib}_FOUND)
		include_directories(${${lib}_INCLUDE_DIRS})
		add_definitions(${${lib}_DEFINITIONS})
	endif (${lib}_FOUND)
endforeach(lib)

# Set default compile flags for GCC
if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, enabling warnings")
	# Magick++ on OSX uses long long and thus cannot take -pedantic
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -Wall -Wextra")
endif(CMAKE_COMPILER_IS_GNUCXX)

if (LibXML++_FOUND)
	if (Boost_FOUND)
		if (Magick++_FOUND)
			add_executable(ss_extract ss_extract.cpp pak.cpp ipu_conv.cpp ss_cover.cpp)
			target_link_libraries(ss_extract ${LibXML++_LIBRARIES} ${Boost_LIBRARIES} ${Magick++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
			set(targets ${targets} ss_extract)
		else (Magick++_FOUND)
			message("No Magick++ found, not building ss_extract")
		endif (Magick++_FOUND)
	else (Boost_FOUND)
		message("No Boost.Filesystem found, not building ss_extract")
	endif (Boost_FOUND)

	if (Magick++_FOUND)
		add_executable(ss_cover_conv cover_conv.cpp pak.cpp ss_cover.cpp)
		target_link_libraries(ss_cover_conv ${Magick++_LIBRARIES} ${LibXML++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
		set(targets ${targets} ss_cover_conv)
	else (Magick++_FOUND)
		message("No Magick++ found, not building ss_cover_conv")
	endif (Magick++_FOUND)
else (LibXML++_FOUND)
	message("No LibXML++ found, not building ss_extract nor ss_cover_conv")
endif (LibXML++_FOUND)

if (Boost_FOUND)
	add_executable(ss_pak_extract pak_extract.cpp pak.cpp)
	target_link_libraries(ss_pak_extract ${Boost_LIBRARIES})
	if (Z_FOUND)
		add_executable(itg_pck itg_pck.cc)
		target_link_libraries(itg_pck ${Boost_LIBRARIES} ${Z_LIBRARIES})
	endif()
endif (Boost_FOUND)

add_executable(ss_adpcm_decode adpcm_decode.cpp pak.cpp)
add_executable(ss_ipu_decode ipu_decode.cpp)
add_executable(ss_ipu_conv ipu_conv.cpp ipuconvmain.cpp pak.cpp)
set(targets ${targets} ss_pak_extract ss_adpcm_decode ss_ipu_decode ss_ipu_conv itg_pck)

# add install target:
install(TARGETS ${targets} DESTINATION bin)

=== libs/libda/CMakeLists.txt ===
project(libda)
cmake_minimum_required(VERSION 2.6)
cmake_policy(VERSION 2.6)

set(LibDA_VERSION_MAJOR 1)
set(LibDA_VERSION_MINOR 0)
set(LibDA_VERSION "${LibDA_VERSION_MAJOR}.${LibDA_VERSION_MINOR}")

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=Release. Use ccmake to set a proper value.")
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug Release." FORCE)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

set(LIB_SUFFIX "" CACHE STRING "Optional suffix to use on lib folders (e.g. 64 for lib64)")
set(LibDA_CMAKE_DIR share/libda/cmake CACHE STRING "Relative path (from prefix) where to put CMake configuration files")

if(SLAVE_LIB)
	set(LibDA_PLUGIN_FOLDER "performous/libda-${LibDA_VERSION_MAJOR}")
else()
	set(LibDA_PLUGIN_FOLDER "libda-${LibDA_VERSION_MAJOR}")
endif()

set(LibDA_PLUGIN_DIR "lib${LIB_SUFFIX}/${LibDA_PLUGIN_FOLDER}")

include_directories(include)

# Store version data in config.h
set(CONFIG_H ${CMAKE_CURRENT_BINARY_DIR}/libda/config.h)
configure_file(cmake/config.h.in ${CONFIG_H} ESCAPE_QUOTES @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT SLAVE_LIB)
	include(cmake/libda-packaging.cmake)
	# Install include files
	file(GLOB HEADER_FILES "include/libda/*")
	install(FILES ${HEADER_FILES} ${CONFIG_H} DESTINATION include/libda)
	# Generate CMake scripts for finding the library
	add_subdirectory(cmake)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -Wall -Wextra")
	if(NOT WIN32)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
	endif(NOT WIN32)
endif(CMAKE_COMPILER_IS_GNUCXX)

set(Boost_USE_STATIC_LIBS OFF)
set(Boost_USE_MULTITHREAD ON)
find_package(Boost 1.36 REQUIRED COMPONENTS thread date_time system filesystem)
include_directories(${Boost_INCLUDE_DIRS})

if(SLAVE_LIB)
	set(Plugin++_LIBRARIES da)
else()
	find_package(Plugin++ REQUIRED)
	include_directories(${Plugin++_INCLUDE_DIRS})
endif()

add_subdirectory(src)
add_subdirectory(plugins)

=== libs/plugin++/CMakeLists.txt ===
project(Plugin++)
cmake_minimum_required(VERSION 2.6)

set(Plugin++_VERSION_MAJOR 1)
set(Plugin++_VERSION_MINOR 0)
set(Plugin++_VERSION "${Plugin++_VERSION_MAJOR}.${Plugin++_VERSION_MINOR}")

# Avoid source tree pollution
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not permitted. Make a separate folder for building:\nmkdir build; cd build; cmake ..\nBefore that, remove the files already created:\nrm -rf CMakeCache.txt CMakeFiles")
endif()

# Add a sensible build type default and warning because empty means no optimization and no debug info.
if(NOT CMAKE_BUILD_TYPE)
	message("WARNING: CMAKE_BUILD_TYPE is not defined!\n         Defaulting to CMAKE_BUILD_TYPE=Release. Use ccmake to set a proper value.")
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: Debug Release." FORCE)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

include_directories(include)

set(Plugin++_CMAKE_DIR share/plugin++/cmake CACHE STRING "Relative path (from prefix) where to put CMake configuration files")
set(LIB_SUFFIX "" CACHE STRING "Optional suffix to use on lib folders (e.g. 64 for lib64)")

if(CMAKE_COMPILER_IS_GNUCXX)
	message(STATUS "GCC detected, adding compile flags")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -Wall -Wextra")
endif()

add_library(plugin++ STATIC src/dll.cc src/execname.cc src/loader.cc)

find_package(DL REQUIRED)
include_directories(${DL_INCLUDE_DIRS})
target_link_libraries(plugin++ ${DL_LIBRARIES})

find_package(Boost 1.36 REQUIRED COMPONENTS filesystem)
include_directories(${Boost_INCLUDE_DIRS})
target_link_libraries(plugin++ ${Boost_LIBRARIES})

add_definitions("-DLIB_SUFFIX=\"${LIB_SUFFIX}\"")

set_target_properties(plugin++ PROPERTIES
	INSTALL_NAME_DIR @rpath
	VERSION "${Plugin++_VERSION}"
	SOVERSION "${Plugin++_VERSION_MAJOR}"
	DEBUG_POSTFIX -d
	INSTALL_RPATH_USE_LINK_PATH TRUE
)

# Store version data in config.h
set(CONFIG_H ${CMAKE_CURRENT_BINARY_DIR}/plugin++/config.h)
configure_file(cmake/config.h.in ${CONFIG_H} ESCAPE_QUOTES @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT SLAVE_LIB)
	include(cmake/plugin++-packaging.cmake)

	install(TARGETS plugin++ EXPORT Plugin++ DESTINATION lib${LIB_SUFFIX})

	FILE(GLOB HEADER_FILES "include/plugin++/*")
	install(FILES ${HEADER_FILES} ${CONFIG_H} DESTINATION include/plugin++)
	
	# Install/generate CMake files for finding Plugin++
	add_subdirectory(cmake)
endif()

=== libs/libda/cmake/CMakeLists.txt ===
set(LibDAConf ${CMAKE_CURRENT_BINARY_DIR}/LibDAConfig.cmake)
set(LibDAConfVer ${CMAKE_CURRENT_BINARY_DIR}/LibDAConfigVersion.cmake)
configure_file(LibDAConfig.cmake.in ${LibDAConf} ESCAPE_QUOTES @ONLY)
configure_file(LibDAConfigVersion.cmake.in ${LibDAConfVer} ESCAPE_QUOTES @ONLY)
install(EXPORT LibDA DESTINATION ${LibDA_CMAKE_DIR})
install(FILES
	${LibDAConf}
	${LibDAConfVer}
	DESTINATION ${LibDA_CMAKE_DIR}
)

=== libs/libda/examples/CMakeLists.txt ===
project("Libda examples" CXX)
cmake_minimum_required(VERSION 2.4)

add_executable(da_capture capture.cpp)
target_link_libraries(da_capture da)
install(TARGETS da_capture DESTINATION bin)

## performous 0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-project(Performous CXX)
+project(Performous CXX C)
 cmake_minimum_required(VERSION 2.6)
 cmake_policy(VERSION 2.6)
-set(PROJECT_VERSION "0.5.1")
+set(PROJECT_VERSION "0.6.1")
 
 # Avoid source tree pollution
 if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
@@ -28,21 +28,16 @@
 
 mark_as_advanced(SHARE_INSTALL)
 
-# Need to find the headers even if they haven't been installed yet:
-include_directories(libs/plugin++/include)
-include_directories(libs/libda/include)
-
 #need to put here do setting LOCALE_DIR variable
 find_package(Gettext)
 if(Gettext_FOUND)
 	if(NOT LOCALE_DIR)
 		if(WIN32)
-			SET(LOCALE_DIR "locale")
-			SET(LOCALE_DIR_WIN32_PREFIX "bin/")
+			SET(LOCALE_DIR "bin/locale")
 		elseif(APPLE)
 			SET(LOCALE_DIR "share/locale")
 		else()#other os
-			SET(LOCALE_DIR "/usr/share/locale")
+			SET(LOCALE_DIR "share/locale")
 		endif(WIN32)
 	endif(NOT LOCALE_DIR)
 	
@@ -58,19 +53,10 @@
 		endif()
 	endif(NOT LOCALE_DIR)
 endif(Gettext_FOUND)
-add_subdirectory(libs)
 add_subdirectory(themes)
 add_subdirectory(data)
 add_subdirectory(game)
 add_subdirectory(docs)
-
-set(LIB_SUFFIX "" CACHE STRING "Optional suffix to use on lib folders (e.g. 64 for lib64)")
-
-option(ENABLE_EDITOR "Enable experimental song editor (doesn't work)" OFF)
-
-if (ENABLE_EDITOR)
-  add_subdirectory(editor)
-endif (ENABLE_EDITOR)
 
 option(ENABLE_TOOLS "Enable extra tools (e.g. Singstar ripper)" ON)
 
@@ -80,4 +66,5 @@
 
 if(WIN32)
 	option(ENABLE_VERSIONING "Add number version information. This allows to add version information to exe. Be carefull, in beta (and a lot useless)" OFF)
+	install(FILES win32/ConfigureSongDirectory.bat DESTINATION bin)
 endif(WIN32)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 set(APPLICATION_FILE "performous.desktop")
 set(PIXMAP_FILE      "performous.xpm")
 set(CONFIG_FILE      "schema.xml")
+set(CONTROLLERS_FILE "controllers.xml")
 
 if(UNIX)
 	install(FILES ${APPLICATION_FILE} DESTINATION "share/applications/")
@@ -8,6 +9,7 @@
 endif(UNIX)
 
 install(FILES ${CONFIG_FILE} DESTINATION "${SHARE_INSTALL}/config/")
+install(FILES ${CONTROLLERS_FILE} DESTINATION "${SHARE_INSTALL}/config/")
 
 file(GLOB XSL_FILES "*.xsl")
 install(FILES ${XSL_FILES} DESTINATION "${SHARE_INSTALL}/xsl/")

=== game/CMakeLists.txt ===
--- 
+++ 
@@ -70,16 +70,8 @@
 include_directories(${Boost_INCLUDE_DIRS})
 list(APPEND LIBS ${Boost_LIBRARIES})
 
-# Libraries are part of Performous build process (for now)
-set(SLAVE_LIBS TRUE)
-if(SLAVE_LIBS)
-	list(APPEND LIBS da plugin++)
-else()
-	set(OUR_LIBS Plugin++ LibDA)
-endif()
-
 # Find all the libs that don't require extra parameters
-foreach(lib ${OUR_LIBS} SDL PangoCairo LibRSVG LibXML++ GLEW AVFormat SWScale OpenGL Z Jpeg Png)
+foreach(lib ${OUR_LIBS} SDL PangoCairo LibRSVG LibXML++ GLEW AVFormat SWScale OpenGL Z Jpeg Png PortAudio)
 	find_package(${lib} REQUIRED)
 	include_directories(${${lib}_INCLUDE_DIRS})
 	list(APPEND LIBS ${${lib}_LIBRARIES})
@@ -96,26 +88,54 @@
 	message(STATUS "Internationalization: Disabled (libintl not found)")
 endif()
 
-find_package(PortMidi)
-if(PortMidi_FOUND)
-	include_directories(${PortMidi_INCLUDE_DIRS})
-	list(APPEND LIBS ${PortMidi_LIBRARIES})
-	add_definitions("-DUSE_PORTMIDI")
-	message(STATUS "MIDI I/O: Enabled")
+if(NOT NO_PORTMIDI)
+	find_package(PortMidi)
+	if(PortMidi_FOUND)
+		include_directories(${PortMidi_INCLUDE_DIRS})
+		list(APPEND LIBS ${PortMidi_LIBRARIES})
+		add_definitions("-DUSE_PORTMIDI")
+		message(STATUS "MIDI I/O: Enabled")
+	else()
+		message(STATUS "MIDI I/O: Disabled (libportmidi not found)")
+	endif()
 else()
-	message(STATUS "MIDI I/O: Disabled (libportmidi not found)")
+	message(STATUS "MIDI I/O: Disabled (explicitly disabled)")
 endif()
+
+if(NOT NO_WEBCAM)
+	find_package(OpenCV)
+	if(OpenCV_FOUND)
+		include_directories(${OpenCV_INCLUDE_DIRS})
+		list(APPEND LIBS ${OpenCV_LIBRARIES})
+		add_definitions("-DUSE_OPENCV")
+		message(STATUS "Webcam support: Enabled")
+	else()
+		message(STATUS "Webcam support: Disabled (libcv/libhighgui not found)")
+	endif()
+else()
+	message(STATUS "Webcam support: Disabled (explicitly disabled)")
+endif()
+
 
 # Set default compile flags for GCC
 if(CMAKE_COMPILER_IS_GNUCXX)
 	message(STATUS "GCC detected, adding compile flags")
 	# -pedantic cannot be used because ffmpeg headers are b0rked
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++98 -Wall -Wextra -Wno-missing-field-initializers")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-missing-field-initializers")
+	# -pthread is unrecognized on Windows and ansi standard causes errors
+	if(NOT WIN32)
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++98 -pthread")
+	endif(NOT WIN32)
 	# Needed for ffmpeg.cc to compile cleanly on OSX (it's a (unsigned long) long story)
 	add_definitions("-D__STDC_CONSTANT_MACROS")
 endif(CMAKE_COMPILER_IS_GNUCXX)
 
-add_executable(performous ${SOURCES} ${SDL_SOURCES} ${RESOURCE_OBJECT})
+if(MSVC)
+	set(SUBSYSTEM_WIN32 WIN32)
+	add_executable(performous-cmd "windows-cmd.cpp")
+	install(TARGETS performous-cmd DESTINATION bin)
+endif(MSVC)
+add_executable(performous ${SUBSYSTEM_WIN32} ${SOURCES} ${SDL_SOURCES} ${RESOURCE_OBJECT})
 target_link_libraries(performous ${LIBS})
 
 # Store library paths in executable

=== themes/CMakeLists.txt ===
FILE(GLOB THEME_FILES "default/*.ogg" "default/*.svg" "default/*.png" "default/*.bmp" "default/*.obj")

install( FILES ${THEME_FILES} DESTINATION ${SHARE_INSTALL}/themes/default/)

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -24,9 +24,13 @@
 if (LibXML++_FOUND)
 	if (Boost_FOUND)
 		if (Magick++_FOUND)
-			add_executable(ss_extract ss_extract.cpp pak.cpp ipu_conv.cpp ss_cover.cpp)
-			target_link_libraries(ss_extract ${LibXML++_LIBRARIES} ${Boost_LIBRARIES} ${Magick++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
-			set(targets ${targets} ss_extract)
+			if (Z_FOUND)
+				add_executable(ss_extract ss_extract.cpp pak.cpp ipu_conv.cpp ss_cover.cpp)
+				target_link_libraries(ss_extract ${LibXML++_LIBRARIES} ${Boost_LIBRARIES} ${Magick++_LIBRARIES} ${Z_LIBRARIES} ${Jpeg_LIBRARIES} ${Tiff_LIBRARIES} ${Png_LIBRARIES} ${Freetype_LIBRARY} ${Magick++_LIBRARIES})
+				set(targets ${targets} ss_extract)
+			else (Z_FOUND)
+				message("No zlib found, not building ss_extract")
+			endif (Z_FOUND)
 		else (Magick++_FOUND)
 			message("No Magick++ found, not building ss_extract")
 		endif (Magick++_FOUND)
@@ -48,16 +52,29 @@
 if (Boost_FOUND)
 	add_executable(ss_pak_extract pak_extract.cpp pak.cpp)
 	target_link_libraries(ss_pak_extract ${Boost_LIBRARIES})
+	set(targets ${targets} ss_pak_extract)
+
+	add_executable(ss_archive_extract archive_extract.cpp)
+	target_link_libraries(ss_archive_extract ${Boost_LIBRARIES})
+	set(targets ${targets} ss_archive_extract)
+
 	if (Z_FOUND)
 		add_executable(itg_pck itg_pck.cc)
 		target_link_libraries(itg_pck ${Boost_LIBRARIES} ${Z_LIBRARIES})
+		set(targets ${targets} itg_pck)
+
+		add_executable(ss_chc_decode ss_chc_decode.cpp)
+		target_link_libraries(ss_chc_decode ${Boost_LIBRARIES} ${Z_LIBRARIES})
+		set(targets ${targets} ss_chc_decode)
 	endif()
 endif (Boost_FOUND)
 
+add_subdirectory(gh_fsb)
+add_executable(gh_xen_decrypt gh_xen_decrypt.cpp)
 add_executable(ss_adpcm_decode adpcm_decode.cpp pak.cpp)
 add_executable(ss_ipu_decode ipu_decode.cpp)
 add_executable(ss_ipu_conv ipu_conv.cpp ipuconvmain.cpp pak.cpp)
-set(targets ${targets} ss_pak_extract ss_adpcm_decode ss_ipu_decode ss_ipu_conv itg_pck)
+set(targets ${targets} gh_xen_decrypt ss_adpcm_decode ss_ipu_decode ss_ipu_conv)
 
 # add install target:
 install(TARGETS ${targets} DESTINATION bin)

=== debian/changelog ===
performous (0.6.1-5) unstable; urgency=low

  * Team upload.
  * Check for jpeglib.h which is actually included instead of jconfig.h.
    The latter is installed in multiarch location. Patch from Ilya Barygin.
    (Closes: #659740)
  * Add build-arch and build-indep targets.
  * Fix Vcs-Browser link.

 -- Felix Geyer <debfx-pkg@fobos.de>  Tue, 31 Jan 2012 15:26:47 +0100

performous (0.6.1-4) unstable; urgency=low

  * Team upload.
  * Add missing include for libav0.8. (Closes: #654221)
  * Use xz compression for binary packages.
  * Remove quilt references from debian/control and debian/rules.
    The package already uses the 3.0 (quilt) source format.
  * Bump Standards-Version to 3.9.2 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 15 Jan 2012 22:48:58 +0100

performous (0.6.1-3) unstable; urgency=low

  * Team upload.
  * Remove deprecated ffmpeg/libav API functions. This prevents a
    FTBFS when libav/0.7 is uploaded to unstable. Patch by Scott
    Kitterman (Closes: #637105)
  * Drop transition package ultrastar-ng now that Squeeze is released

 -- Moritz Muehlenhoff <jmm@debian.org>  Wed, 24 Aug 2011 22:33:21 +0200

performous (0.6.1-2) unstable; urgency=low

  * Team upload.

  [ Evgeni Golov ]
  * Set BOOST_FILESYSTEM_VERSION=2 to prevent FTBFS with boost >= 1.46
    Closes: #625109

  [ Bruno "Fuddl" Kleinert ]
  * Follow libmagick transition and build-depend on libmagick++-dev instead of
    libmagick++9-dev, now. (Closes: #625610)

 -- Bruno "Fuddl" Kleinert <fuddl@debian.org>  Thu, 09 Jun 2011 18:14:57 +0200

performous (0.6.1-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New upstream release
  * Using source package format "3.0 (quilt)"
  * Upgraded Standards-Version from 3.8.3 to 3.9.1
  * Added a recommend for vorbis-tools in performous-tools. Closes: #567807
  * Removed configure target as dependency from clean in debian/rules

 -- Miriam Ruiz <little_miry@yahoo.es>  Wed, 03 Nov 2010 22:57:47 +0100

performous (0.5.1-1) unstable; urgency=low

  * New upstream release.
    - mainly bugfix
    - adding some new instrument auto recognized
  * Updated package description in debian/control

 -- Miriam Ruiz <little_miry@yahoo.es>  Sat, 16 Jan 2010 16:00:15 +0100

performous (0.5.0-1) unstable; urgency=low

  * New upstream release

 -- Miriam Ruiz <little_miry@yahoo.es>  Wed, 13 Jan 2010 23:22:55 +0100

performous (0.4.0-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New upstream release. Closes: #558689
  * Updated package description
  * Upgraded Standards-Version from 3.8.2 to 3.8.3
  * Added to Build-Depends: pkg-config
  * Define in rules which plugins to compile.
    See: libs/libda/plugins/CMakeLists.txt
  * Fixed Vcs-Svn and Vcs-Browser in debian/control
  * Added very simple man page for performous tools

 -- Miriam Ruiz <little_miry@yahoo.es>  Wed, 02 Dec 2009 22:31:10 +0100

performous (0.3.2-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New upstream release

 -- Miriam Ruiz <little_miry@yahoo.es>  Tue, 28 Jul 2009 00:43:34 +0200

performous (0.3.1-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New upstream release
  * Added binary packages performous-tools and performous-tools-dbg
  * Updated patches
  * Upgraded Standards-Version to 3.8.2
  * New build dependency: libglew1.5-dev
  * It depends on cmake (>= 2.6) now

 -- Miriam Ruiz <little_miry@yahoo.es>  Sat, 11 Jul 2009 20:22:04 +0200

performous (0.3.0-3) unstable; urgency=low

  [ Barry deFreese ]
  * boost_fix.patch - Build with newer boost. (Closes: #530473).
  * gcc_44.patch - Build with gcc-4.4. (Closes: #510848).
    + Thanks to Martin Michlmayr for the patch.
  * Add Section: debug to -dbg package.
  * Fix some symantic errors in package description. (Closes: #517620).
  * Bump Standards Version to 3.8.1.

 -- Miriam Ruiz <little_miry@yahoo.es>  Thu, 28 May 2009 22:38:15 +0200

performous (0.3.0-2) unstable; urgency=low

  [ Ansgar Burchardt ]
  * debian/copyright: Fix typo.

  [ Miriam Ruiz ]
  * Uploaded to sid
  * Do not depend on the dependencies of the plugins
  * Recommend the dependencies of the ALSA plugin

 -- Miriam Ruiz <little_miry@yahoo.es>  Tue, 23 Dec 2008 22:19:45 +0100

performous (0.3.0-1) experimental; urgency=low

  * UltraStar NG is now called Performous. Package renamed to performous.
  * New homepage: http://performous.org/
  * New building system: cmake
  * Updated build dependencies
  * Removed ultrastar-ng-xine and ultrastar-ng-gstreamer packages
  * Added package performous-dbg with the debugging symbols

 -- Miriam Ruiz <little_miry@yahoo.es>  Tue, 11 Nov 2008 21:11:40 +0100

ultrastar-ng (0.2.1-1) unstable; urgency=low

  [ Miriam Ruiz ]
  * New Upstream Release (Closes: #453132)
  * Removed unneeded patches
  * Added packages to build deps:
    + libtool
    + portaudio19-dev | portaudio-dev
    + libboost-dev, libboost-thread-dev, libboost-serialization-dev
    + libboost-program-options-dev, libboost-regex-dev
  * Moved shared objects to private directory: /usr/lib/ultraster-ng
  * Added rpath to binaries to search for shared objects in the private dir
  * Uses ultrastar-ng-gstreamer as default, instead of ultrastar-ng-xine,
    since there are significantly less issues with GStreamer.
  * Added patch to fix upstream desktop file
  * Added -Wl,-as-needed to LDFLAGS
  * Replaced fftw3-dev by libfftw3-dev in build dependencies.
  * Standards-Version upgraded to 3.7.3

  [ Mario Bonino ]
  * Fixed data/Makefile.am to install .desktop file and icon

  [ Jon Dowland ]
  * add Homepage: control field to source stanza
  * fix a bashism in debian/rules (Closes: #478634)

  [ Ansgar Burchardt ]
  * debian/control: Change XS-Vcs-* to Vcs-*
  * Remove Homepage semi-field from description

 -- Miriam Ruiz <little_miry@yahoo.es>  Sat, 07 Jun 2008 16:43:18 +0200

ultrastar-ng (0.1.4-2) unstable; urgency=low

  [ Miriam Ruiz ]
  * Added patch to support previewing ogg files with xine (Closes: #430531)


=== debian/control ===
Source: performous
Section: games
Priority: extra
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Miriam Ruiz <little_miry@yahoo.es>
Build-Depends: debhelper (>= 7),
 cmake (>= 2.6), pkg-config, help2man, gettext,
 libgl1-mesa-dev, libsdl1.2-dev, libcairo2-dev, librsvg2-dev,
 libboost-thread-dev (>= 1.36), libboost-serialization-dev (>= 1.36),
 libboost-program-options-dev (>= 1.36), libboost-regex-dev (>= 1.36),
 libboost-filesystem-dev (>= 1.36),
 libavcodec-dev, libavformat-dev, libswscale-dev,
 libmagick++-dev, libsamplerate0-dev, libxml++2.6-dev,
 libasound2-dev, libjack-dev, libpulse-dev, portaudio19-dev,
 libgstreamer0.10-dev, libglew1.5-dev
Standards-Version: 3.9.2
Vcs-Svn: svn://svn.debian.org/svn/pkg-games/packages/trunk/performous/
Vcs-Browser: http://anonscm.debian.org/viewvc/pkg-games/packages/trunk/performous/
Homepage: http://performous.org/

Package: performous
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Recommends: ${alsalibs:Recommends}
Conflicts: ultrastar-ng (<< 0.3.0)
Replaces: ultrastar-ng (<< 0.3.0)
Provides: ultrastar-ng
Description: karaoke game that allows user supplied songs
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.

Package: performous-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Recommends: vorbis-tools
Suggests: performous
Description: karaoke game that allows user supplied songs - tools
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes some tools for converting original Singstar DVDs to
 the format used by Performous.

Package: performous-dbg
Section: debug
Priority: extra
Architecture: any
Depends: performous (= ${binary:Version}) | performous-tools (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: dpkg (>= 1.15.6)
Description: karaoke game that allows user supplied songs - debug
 A karaoke, band and dancing game where one or more players perform a song
 and the game scores their performances. Supports songs in UltraStar,
 Frets on Fire and StepMania formats. Microphones and instruments from
 SingStar, Guitar Hero and Rock Band as well as some dance pads are
 autodetected.
 .
 This package includes the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

BUILD_TREE=$(CURDIR)/build-tree

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Perform an out-of-tree build to keep a clean source tree
	rm -rf $(BUILD_TREE)
	mkdir $(BUILD_TREE)
	cd $(BUILD_TREE); cmake .. \
		-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
		-DCMAKE_INSTALL_PREFIX:STRING="/usr" \
		-DLibDA_AUTODETECT_PLUGINS:BOOL=OFF \
		-DLibDA_PLUGIN_ALSA:BOOL=ON \
		-DLibDA_PLUGIN_GSTREAMER:BOOL=ON \
		-DLibDA_PLUGIN_JACK:BOOL=ON \
		-DLibDA_PLUGIN_PORTAUDIO:BOOL=ON \
		-DLibDA_PLUGIN_PULSE:BOOL=ON \
		-DLibDA_PLUGIN_TESTING:BOOL=OFF \
		-DCMAKE_C_FLAGS:STRING="$(CFLAGS)"
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp 
	dh_testdir
	cd $(BUILD_TREE); $(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	if [ -d $(BUILD_TREE) ]; then cd $(BUILD_TREE); $(MAKE) clean; fi
	rm -fr $(BUILD_TREE)
	$(MAKE) -C debian/h2m clean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	cd $(BUILD_TREE); $(MAKE) install DESTDIR=$(CURDIR)/debian/performous
	$(MAKE) -C debian/h2m
	cp themes/default/icon.png $(CURDIR)/debian/performous/usr/share/pixmaps/performous.png
	mkdir -p  $(CURDIR)/debian/performous/usr/share/games/ultrastar/songs
	mv $(CURDIR)/debian/performous/usr/bin $(CURDIR)/debian/performous/usr/games

	# Remove development stuff
	rm -rf $(CURDIR)/debian/performous/usr/include
	rm -rf $(CURDIR)/debian/performous/usr/lib/*.a

	# Move tools to their own package
	mkdir -p $(CURDIR)/debian/performous-tools/usr/games
	cd $(CURDIR)/debian/performous/usr/games/ && \
		for i in ss_adpcm_decode ss_cover_conv ss_ipu_conv ss_ipu_decode \
			ss_archive_extract ss_chc_decode ss_pak_extract ss_extract \
			gh_fsb_decrypt gh_xen_decrypt itg_pck; do \
		mv $(CURDIR)/debian/performous/usr/games/"$$i" $(CURDIR)/debian/performous-tools/usr/games/ ; \
		done

# Build architecture independant packages using the common target.
binary-indep:
	dh_testdir
	dh_testroot
	dh_install -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

# Build architecture dependant packages using the common target.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installmenu -a
	dh_installman -a
	dh_install -a
	dh_icons -a
	dh_link -a
	dh_strip --dbg-package=performous-dbg
	dh_compress -a 
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a \
		-Xusr/lib/performous/libda-1/
	dh_shlibdeps -a \
		-Xusr/lib/performous/libda-1/libda.a \
		-Xusr/lib/performous/libda-1/libda_audio_dev_gst.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_jack.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_pa19.so \
		-Xusr/lib/performous/libda-1/libda_audio_dev_pulse.so \
		-- -dRecommends -palsalibs
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary: binary-arch binary-indep
.PHONY: build-arch build-indep build clean binary-indep binary-arch binary install configure

=== debian/watch ===
# Watch control file for uscan
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Find new files on sourceforge, for debscripts >= 2.9
http://sf.net/performous/Performous-(.*)-Source\.tar\.bz2
